$PELLESC
$DLL

GLOBAL musicdata[65536] AS CHAR
global mmlstring[65536] AS CHAR

global mmlptr
global dataptr
global mmlcmd AS UCHAR
global tmpcmd AS UCHAR
global keepgoing

global octmult
global octnum
global notenum
global notenum2
global notelength
GLOBAL defnotelength AS UCHAR
global musicdata as LPSTR
sub Mmlc_Init(dnl) EXPORT
	defnotelength=dnl
	notelength=dnl
	octnum=0
end sub

function CompileMml(s$) AS LPSTR EXPORT

	for dataptr=0 to 65535
		musicdata[dataptr]=0
	next
	mmlptr=0
	dataptr=0
	keepgoing=1
	mmlstring$=s$


	while keepgoing=1
		mmlcmd=mmlstring[mmlptr]
		mmlptr++
		if mmlcmd>0 then
			ProcessMml()
		end if
		if mmlcmd=0 then
			keepgoing=0
		end if
	wend

		musicdata[dataptr+1]=0x65
		musicdata[dataptr+2]=0x6e
		musicdata[dataptr+3]=0x64
		musicdata[dataptr]=0
		dim pmusicdata as LPSTR
		pmusicdata=strptr(musicdata$)

	function=pmusicdata
end function

Sub ProcessMml()
	select case mmlcmd
		case 0x21
			tmpcmd=0xf6
			
			if mmlstring[mmlptr]=0x2d then
				tmpcmd=0xf2
				mmlptr++
			end if
			musicdata[dataptr]=tmpcmd
			dataptr++
			musicdata[dataptr]=GetThreeDigits()
			dataptr++
		case 0x23
			tmpcmd=0xfd
			musicdata[dataptr]=tmpcmd
			dataptr++
			musicdata[dataptr]=GetThreeDigits()
			dataptr++
		case 0x26
			tmpcmd=0xf9
			musicdata[dataptr]=tmpcmd
			dataptr++
			musicdata[dataptr]=GetNoteLength()
			dataptr++
		case 0x2a
			tmpcmd=0xf5
			musicdata[dataptr]=tmpcmd
			dataptr++
			tmpcmd=GetThreeDigits()
			if tmpcmd>1 then tmpcmd=1
			musicdata[dataptr]=tmpcmd
			dataptr++
		case 0x3a
			tmpcmd=0xf1
			musicdata[dataptr]=tmpcmd
			dataptr++
			musicdata[dataptr]=0
			dataptr++
		case 0x3b
			keepgoing=0
		case 0x3c
			if octnum>0 then
				octnum--
			end if
		case 0x3e
			if octnum<7 then
				octnum++
			end if
		case 0x40
			tmpcmd=0xff
			musicdata[dataptr]=tmpcmd
			dataptr++
			musicdata[dataptr]=GetThreeDigits()
			dataptr++
		case 0x4c
			tmpcmd=0xf4
			musicdata[dataptr]=tmpcmd
			dataptr++
			musicdata[dataptr]=0
			dataptr++
		case 0x56
			tmpcmd=0xf3
			musicdata[dataptr]=tmpcmd
			dataptr++
			tmpcmd=GetThreeDigits()
			if tmpcmd>1 then tmpcmd=1
			musicdata[dataptr]=tmpcmd
			dataptr++
		case 0x5b
			tmpcmd=0xfb
			musicdata[dataptr]=tmpcmd
			dataptr++
			musicdata[dataptr]=0
			dataptr++
		case 0x5d
			tmpcmd=0xfa
			musicdata[dataptr]=tmpcmd
			dataptr++
			musicdata[dataptr]=GetThreeDigits()
			dataptr++
		case 0x61 to 0x67
			notenum=mmlcmd-0x60
			if notenum<3 then
				notenum=notenum+7
			end if
			notenum=notenum-2

			select case notenum
				case 1
					notenum=1
				case 2
					notenum=3
				case 3
					notenum=5
				case 4
					notenum=6
				case 5
					notenum=8
				case 6
					notenum=10
				case 7
					notenum=12
			end select
			tmpcmd=mmlstring[mmlptr]
			select case tmpcmd
				case 0x2d
					notenum--
					mmlptr++
				case 0x2b
					notenum++
					mmlptr++
			end select
			octmult=octnum*12
			notenum=notenum+octmult
			notelength=GetNoteLength()
			musicdata[dataptr]=notenum
			dataptr++
			musicdata[dataptr]=notelength
			dataptr++
		case 0x6f
			tmpcmd=mmlstring[mmlptr]
			tmpcmd=tmpcmd-0x30
			if tmpcmd>7 then
				tmpcmd=7
			end if
			octnum=tmpcmd
			mmlptr++
		case 0x6c
			defnotelength=GetNoteLength()
		case 0x70
			tmpcmd=0xf8
			musicdata[dataptr]=tmpcmd
			dataptr++
			tmpcmd=GetThreeDigits()
			if tmpcmd>3 then tmpcmd=3
			tmpcmd=tmpcmd*64
			musicdata[dataptr]=tmpcmd
			dataptr++
		case 0x72
			notenum=0x80
			notelength=GetNoteLength()
			musicdata[dataptr]=notenum
			dataptr++
			musicdata[dataptr]=notelength
			dataptr++
		case 0x74
			tmpcmd=0xfc
			musicdata[dataptr]=tmpcmd
			dataptr++
			musicdata[dataptr]=GetThreeDigits()
			dataptr++
		case 0x76
			tmpcmd=0xf7
			musicdata[dataptr]=tmpcmd
			dataptr++
			tmpcmd=GetThreeDigits()
			if tmpcmd>15 then tmpcmd=15
			select case tmpcmd
				case 0
					tmpcmd=36
				case 1
					tmpcmd=34
				case 2
					tmpcmd=32
				case 3
					tmpcmd=30
				case 4
					tmpcmd=28
				case 5
					tmpcmd=26
				case 6
					tmpcmd=24
				case 7
					tmpcmd=22
				case 8
					tmpcmd=20
				case 9
					tmpcmd=18
				case 10
					tmpcmd=16
				case 11
					tmpcmd=14
				case 12
					tmpcmd=12
				case 13
					tmpcmd=10
				case 14
					tmpcmd=8
				case 15
					tmpcmd=6
			end select
			musicdata[dataptr]=tmpcmd
			dataptr++
		case else

	end select
end sub

function GetNoteLength() AS UCHAR
	dim z AS UCHAR
	dim nl AS UCHAR
	nl=defnotelength
	z=mmlstring[mmlptr]
	select case z
		case 0x25
			mmlptr++
			nl=GetThreeDigits()
		case 0x30 to 0x39
			mmlptr++
			z=z-0x30
			select case z
				case 1
					nl=96
					z=mmlstring[mmlptr]
					select case z
						case 0x32
							nl=8
							mmlptr++
						case 0x36
							nl=6
							mmlptr++
					end select
				case 2
					nl=48
					z=mmlstring[mmlptr]
					select case z
						case 0x34
							nl=4
							mmlptr++
					end select
				case 3
					nl=32
					z=mmlstring[mmlptr]
					select case z
						case 0x32
							nl=3
							mmlptr++
					end select
				case 4
					nl=24
					z=mmlstring[mmlptr]
					if z=0x38 then
						nl=2
						mmlptr++
					end if
				case 6
					nl=16
				case 8
					nl=12
				case 9
					z=mmlstring[mmlptr]
					if z=0x36 then
						nl=1
						mmlptr++
					end if
			end select
		case else
	end select


	z=mmlstring[mmlptr]
	if z=0x2e then
		nl=nl+(nl/2)
		mmlptr++
		z=mmlstring[mmlptr]
		if z=0x2e then
			nl=nl+(nl/6)
		end if
	end if
	function=nl
end function

function GetThreeDigits() AS UCHAR
	dim z AS UCHAR
	dim td AS UCHAR
	td=0
	z=mmlstring[mmlptr]
	select case z
		case 0x30 to 0x39
			mmlptr++
			td=z-0x30
			z=mmlstring[mmlptr]
			select case z
				case 0x30 to 0x39
					mmlptr++
					td=(td*10)+(z-0x30)
					z=mmlstring[mmlptr]
					select case z
						case 0x30 to 0x39
							mmlptr++
							td=(td*10)+(z-0x30)
					end select
			end select
	end select
	function=td
end function